/* Takes care of saving and loading data from files */
#define FLL 0
#define FPL 1
#define FN  2
#define FT  3

#define load_log_link(idx,buff) load_entry(FLL,idx,buff)
#define load_phy_link(idx,buff) load_entry(FPL,idx,buff)
#define load_node(idx,buff)     load_entry(FN, idx,buff)
#define load_tree(idx,buff)     load_entry(FT, idx,buff)

int find_log_link PROTO((int sn, int dn));
int add_log_link PROTO((int n,u_int32 src,int dn, u_int32 dst,int fl));
int add_phy_link PROTO((int ps,int pd,int ls,int ld));
int     find_node_by_name PROTO((char *str));
int     find_node_by_addr PROTO((u_int32 addr));
int     assert_node_by_addr PROTO((u_int32 addr));
node_t *mget_node PROTO((int32 idx));
int     add_node PROTO((int32 addr));
int     load_entry PROTO((int32  fn, int32  idx, void *buff));
int     num_nodes  PROTO(());
int     num_links  PROTO(());
log_link_t *get_log_link PROTO((int32 idx));
log_link_t *find_ifc     PROTO((int32 sn, int32 dn));
int     save_everything PROTO(());

/*
 * GIVEN: source IP address, destination IP address, and destination
 *        address mask (which is 0 when the destination is a host)
 * FIND : link index
 */
int assert_log_link PROTO((u_int32 srcaddr, u_int32 dstaddr, u_int32 dstmask));
int assert_node_addr PROTO((int n, u_int32 addr));
int assert_subnet PROTO((u_int32 addr));
int assert_subnet_link PROTO((int subnet, u_int32 addr));
int find_subnet PROTO((u_int32 addr));
void close_files();
int num_log_links();
void add_iface_to_subnet PROTO((int subnet, u_int32 addr));
int rm_log_link PROTO((int ln));
int rm_phy_link PROTO((int ln));
int is_ndeleted PROTO((int i));
void assert_subnet_mask();
