/*
 * 'flags' byte values in DVMRP_NEIGHBORS2 reply.
 */
#define DVMRP_NF_TUNNEL		0x01	/* neighbors reached via tunnel */
#define DVMRP_NF_SRCRT		0x02	/* tunnel uses IP source routing */
#define DVMRP_NF_PIM            0x04    /* neighbor is a PIM neighbor */
#define DVMRP_NF_DOWN		0x10	/* kernel state of interface */
#define DVMRP_NF_DISABLED	0x20	/* administratively disabled */
#define DVMRP_NF_QUERIER	0x40	/* I am the subnet's querier */
#define DVMRP_NF_LEAF           0x80    /* Neighbor reports that it is a leaf */

#define LF_HIGHLIGHT 0x0100
#define LF_MULTIPLE  0x0200
#define LF_INTREE    0x0400 /* for dvmrp */
#define LF_CHILD     0x0800 /* for dvmrp */
#define LF_LEAF      0x1000 /* for dvmrp */
#define LF_PARENT    0x2000 /* for dvmrp */
#define LF_SUBNET    0x4000 /* for dvmrp ??? */
#define LF_SUSPECT   0x8000 /* for dvmrp ??? */

#define LH_NONE      0
#define LH_WEIRD     1
#define LH_SRCTREE   2
#define LH_SDPATH    3
#define LH_PROPOSED  4
#define LH_CUSTOM    5
#define LH_UP        6

#define LD_ALL       0
#define LD_BIDIR     1
#define LD_SRCTREE   2
#define LD_SDPATH    3
#define LD_UP        4
#define LD_CUSTOM    5

#define LS_METTHR      0
#define LS_CUSTOM      1
#define LS_NONE        2

#define ND_CUSTOM      2
#define ND_INCLOUD     3  /* in current cloud */

#define NI_NONE        0
#define NI_WORLD       1  /* not available */
#define NI_DISPLAYED   2
#define NI_CUSTOM      3

#define INITIAL_ZOOM   0.33

int ehighlight PROTO((int ln));
int nhighlight PROTO((int idx));
void wtmp_display PROTO((char *str));
char *query PROTO((char *pr));
char *yesno PROTO((char *pr));
int X PROTO((node_t *node));
int Y PROTO((node_t *node));
int redraw PROTO(());
void init_view PROTO(());
int exit_view PROTO(());
int get_char PROTO(()); 
char *statstr PROTO((int st));
void flagstr PROTO((char *buff,log_link_t *edge));
void add_msg PROTO((char *msg));
void show_detail PROTO((int v));
void goto_node PROTO((int i));
int view PROTO((int x, int y));
void refresh_display PROTO(());
char *cond_text PROTO((cond_t*));


int do_output PROTO((ClientData data, Tcl_Interp *tcl, int argc, char *argv[]));
int do_fillin PROTO((ClientData data, Tcl_Interp *tcl, int argc, char *argv[]));
char *cb_setsrc PROTO((ClientData clientData, Tcl_Interp *interp, char *name1, char *name2, int flags));
char *cb_fillin PROTO((ClientData clientData, Tcl_Interp *interp, char *name1, char *name2, int flags));
char *cb_terminals PROTO((ClientData clientData, Tcl_Interp *interp, char *name1, char *name2, int flags));
char *cb_fontsize PROTO((ClientData clientData, Tcl_Interp *interp, char *name1, char *name2, int flags));
char *set_X PROTO((ClientData clientData, Tcl_Interp *interp, char *name1, char *name2, int flags));
char *set_Y PROTO((ClientData clientData, Tcl_Interp *interp, char *name1, char *name2, int flags));
void fillin_nodes PROTO(( int cloud_idx, int idx ));
char *cloudvar();
void set_node_display PROTO((int node_idx));
void notify PROTO((char *title, char *msg));
int ndisplay PROTO((int idx));
int is_ndisplayed PROTO((int idx));
int is_edisplayed PROTO((int idx));
int is_ncloud PROTO((int idx));
int is_cdisplayed PROTO((int idx));
void set_virtual_position PROTO((int root, float x, float y));
char *do_tcl PROTO((char *str));
int ninfo PROTO((int idx));
int xy_idx();
int Xi2c PROTO((int i));
int Yi2c PROTO((int i));
extern void center_node PROTO((int n));
extern void rescale_nodes PROTO(());
