/* $Id: filter.c,v 1.2 1996/04/02 18:53:22 thalerd Exp $
 * -------------------------------------------------------------------------
 *  
 * [C] The Regents of the University of Michigan and Merit Network, Inc. 1996
 * All Rights Reserved 
 *   
 * Permission to use, copy, modify, and distribute this software and its 
 * documentation for any purpose and without fee is hereby granted, provided 
 * that the above copyright notice and this permission notice appear in all 
 * copies of the software and derivative works or modified versions thereof, 
 * and that both the copyright notice and this permission and disclaimer notice 
 * appear in supporting documentation. 
 *  
 * THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER 
 * EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION WARRANTIES OF 
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE REGENTS OF THE 
 * UNIVERSITY OF MICHIGAN AND MERIT NETWORK, INC. DO NOT WARRANT THAT THE 
 * FUNCTIONS CONTAINED IN THE SOFTWARE WILL MEET LICENSEE'S REQUIREMENTS OR 
 * THAT OPERATION WILL BE UNINTERRUPTED OR ERROR FREE. The Regents of the 
 * University of Michigan and Merit Network, Inc. shall not be liable for any 
 * special, indirect, incidental or consequential damages with respect to any 
 * claim by Licensee or any third party arising from use of the software. 
 *
 * -------------------------------------------------------------------------
 */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include <stdio.h>
#include <ctype.h>

int
main()
{
   int c;
   int depth=0;
   int i;

   for (;;) {
      for (c=getchar(); c!=EOF && isspace(c); c=getchar());
      if (c!='#') 
         break;
      for (c=getchar(); c!=EOF && c!='\n'; c=getchar());
   }

   while (c!=EOF) {
      if (c=='{') {
         depth++;
      } else if (c=='}') {
         if (!depth) {
            c = getchar();
            continue;
         }
         depth--;
      } else if (c=='\n') {
         putchar(c);
         for (i=0; i<depth-1; i++)
            putchar(' ');
         for (;;) {
            for (c=getchar(); c!=EOF && isspace(c); c=getchar());
            if (c!='#') 
               break;
            for (c=getchar(); c!=EOF && c!='\n'; c=getchar());
         }
         if (i<depth && c!='}')
            putchar(' ');
         continue;
      }
      putchar(c);
      c = getchar();
   }
   exit(0);
}
