/* $Id: lib.c,v 1.4 1996/02/13 18:33:39 thalerd Exp $
 * -------------------------------------------------------------------------
 *  
 * [C] The Regents of the University of Michigan and Merit Network, Inc. 1996
 * All Rights Reserved 
 *   
 * Permission to use, copy, modify, and distribute this software and its 
 * documentation for any purpose and without fee is hereby granted, provided 
 * that the above copyright notice and this permission notice appear in all 
 * copies of the software and derivative works or modified versions thereof, 
 * and that both the copyright notice and this permission and disclaimer notice 
 * appear in supporting documentation. 
 *  
 * THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER 
 * EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION WARRANTIES OF 
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE REGENTS OF THE 
 * UNIVERSITY OF MICHIGAN AND MERIT NETWORK, INC. DO NOT WARRANT THAT THE 
 * FUNCTIONS CONTAINED IN THE SOFTWARE WILL MEET LICENSEE'S REQUIREMENTS OR 
 * THAT OPERATION WILL BE UNINTERRUPTED OR ERROR FREE. The Regents of the 
 * University of Michigan and Merit Network, Inc. shall not be liable for any 
 * special, indirect, incidental or consequential damages with respect to any 
 * claim by Licensee or any third party arising from use of the software. 
 *
 * -------------------------------------------------------------------------
 */
/* LIB.C - generic library routines */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#define NIL  ((char *)0)

#ifdef HAVE_STRING_H
#include <string.h>
#endif
#include "mview.h"
#include "xalloc.h"

#ifndef HAVE_ASSERT
void
assert(i)
   int i;
{
   if (!i) abort();
}
#endif

/******************************************************************************/
/* SPLIT A STRING INTO AN ARRAY OF FIELDS                                     */
/******************************************************************************/
char **                     /* RETURNS: (nothing)                  */
explode(str,sep)            /* ARGUMENTS:                          */
char *str;                  /*    Filename to read into memory     */
char *sep;                  /*    Field separator string           */
{
   char **mem,*ln,*nstr;
   short lines;
   int max_lines=1;

   for (nstr=str; *nstr; nstr++)
      if (strchr(sep,*nstr))
         max_lines++;
   mem=xalloc(max_lines,sizeof(char *));
   nstr=xstrdup(str);

   if (sep) {
      ln=strtok(nstr,sep);
      for (lines=0; ln && lines<max_lines; lines++) {
/*       while (*ln == ' ') ln++;  * skip leading spaces */
         mem[lines]=xstrdup(ln);
/*       while (strlen(mem[lines]) && mem[lines][ strlen(mem[lines])-1 ] == ' ')
            mem[lines][ strlen(mem[lines])-1 ] = 0; * trash trailing spaces */
         ln = strtok(NIL,sep);
      }
   } else {
      mem[0]=xstrdup(str);
      lines=1;
   }

   mem=xrealloc_array(mem,lines);
   xfree_string(nstr);
   return mem;
}

/******************************************************************************/
/* CHECK FOR A PARTIAL STRING MATCH (required_optional)                       */
/******************************************************************************/
int            /* RETURNS: 1 if match, 0 else        */
match(ent,und) /* ARGUMENTS:                         */
char *ent,     /*    String entered by user          */
     *und;     /*    String with underlines to match */
{
   char *q;
   short n;

   q=strchr(und,'_');          /* "_optional" */
   n=(q)? q-und : strlen(und); /* number of required chars */
   if (!n) return !strlen(ent);     /* dont match "" with anything but "" */
   if (strncasecmp(ent,und,n))                    return 0; /* match before _ */
   if (q && strncasecmp(ent+n,q+1,strlen(ent)-n)) return 0; /* match after  _ */
   if (strlen(ent) > strlen(und)-(q!=0)) return 0; /* no extra chars */
   return 1;
}
