/* Node defines */

/* Status information for a node */
#define ST_PING       0x0001
#define ST_RESPONDING 0x0001 /* Responding to pings                  */
#define ST_MROUTER    0x0002 /* Someone else told us it's an mrouter */
#define ST_MROUTING   0x0004 /* Responding to mrinfo                 */
#define ST_DELETED    0x0010
#define ST_SAVEMASK   0x0717
#define ST_SUBNET     0x0020
#define ST_INTREE     0x0040
#define ST_PROPOSED   0x0800
#define ST_HIGHLIGHT  0x1000
#define ST_REFLEX     0x2000
#define ST_DONTSAVE   0x8000

#define OLDNODETIME 604800 /* 1 week */

char   *org            PROTO((int n));
char   *country        PROTO((int n));
void   remove_outlinks PROTO((int n));

extern int do_fullname PROTO((ClientData data, Tcl_Interp *tcl, int argc, char **argv));
extern char *fullname PROTO((int n));
extern int do_ipstr PROTO((ClientData data, Tcl_Interp *tcl, int argc, char **argv));
extern char *ipstr PROTO((int n, int i));
extern char *hostname PROTO((int n));
extern void name_lookup PROTO((int32 n));
extern void autosys_lookup PROTO((int32 n));
extern void asname_lookup PROTO((int32 n));
extern void snmpaware_lookup PROTO((int32 n));
extern void update_node PROTO((int32 n));
extern void check_node PROTO((int n));
extern int update_link PROTO((u_int32 srcaddr, u_int32 dstaddr, u_int32 dstmask,, u_char metric, u_char thresh, u_char flags));
extern int dump_node PROTO((ClientData data, Tcl_Interp *tcl, int argc, char **argv));
extern void delete_node PROTO((int n));
int needs_updating PROTO((int n));
