#define DELTA 1
#define RATE  2

#define TAB_ALTNETS 6
#define TAB_BOUNDARIES 7
#define TAB_NEIGHBORS 8
#define TAB_VIFS 11

#define dvmrpVInterfaceLocalAddress  ".1.3.6.1.3.62.1.1.3.1.4"
#define dvmrpVInterfaceRemoteAddress ".1.3.6.1.3.62.1.1.3.1.5"
#define dvmrpVInterfaceMetric        ".1.3.6.1.3.62.1.1.3.1.7"
#define dvmrpVInterfaceThresh        ".1.3.6.1.4.1.9.10.2.1.1.4.1.2"
#define dvmrpVInterfaceRateLimit     ".1.3.6.1.3.62.1.1.3.1.8"
#define dvmrpVInterfaceStatus        ".1.3.6.1.3.62.1.1.3.1.13"

#define dvmrpBoundaryStatus   ".1.3.6.1.3.62.1.1.7.1.4"
#define dvmrpAltNetStatus     ".1.3.6.1.3.62.1.1.8.1.4"

/* values for EntryStatus */
#define ENTRY_ACTIVE    1
#define ENTRY_NOTINSERVICE 2
#define ENTRY_NOTREADY     3
#define ENTRY_CREATEANDGO  4
#define ENTRY_CREATEANDWAIT   5
#define ENTRY_DESTROY      6

typedef struct {
   char   opt;
   char **nvars[2];
   char *header;
   char *body;
} table_t;

/* Functions defined in util.c */
extern struct variable_list *vpseek __P((struct variable_list *vp, int i));
extern struct snmp_pdu *snmpget __P((struct snmp_session *ss, int type,
 char **names, int num_names, int *err));
extern struct snmp_session *open_session __P((char *remotehost, int remoteport,
 char *community, int retransmission, int timeout, int *ver));
extern void display_table __P((struct snmp_session *ss, int ver));
extern void expand_str __P((char *body, struct variable_list *vp, 
 char cumul[10][256], char oldcumul[10][256], char nvars, int row, 
 char *output));
extern void accumulate_counter __P((char *cumul, struct variable_list *var));
extern void accumulate_value __P((char *buf, struct variable_list *var));

/* Functions called from util.c which must exist elsewhere */
extern void output_header __P((char *str));
extern void output_row __P((char *str));
extern void setAnswers __P((struct variable_list *vp, char cumul[10][256], 
 char oldcumul[10][256], int nvars, int row));

extern char hostname[80];
extern table_t tables[];
extern int table;
extern int maskout;
extern int mode;
extern int delay_time;
extern int maxcount;
extern char *community;
extern int addronly;
extern int dest_port;
extern char *prefix;
extern struct snmp_session *ss;
extern int retransmission;
extern int timeout;
extern int interrupted;
extern const int tclFlag;
